Index: /trunk/LMDZ.COMMON/libf/evolution/pem.F90
===================================================================
--- /trunk/LMDZ.COMMON/libf/evolution/pem.F90	(revision 2834)
+++ /trunk/LMDZ.COMMON/libf/evolution/pem.F90	(revision 2835)
@@ -3,22 +3,28 @@
 
 ! I   Initialisation
-!    I_a READ run.def , run_pem.def
-!    I_b READ starfi_0.nc
-!    I_c READ GCM data and convert to the physical grid 
-!    I_d Compute tendencies & Save initial situation
+!    I_a READ run.def 
+!    I_b READ of start_evol.nc and starfi_evol.nc
+!    I_c Subslope parametrisation
+!    I_d READ GCM data and convert to the physical grid 
+!    I_e Initialisation of the PEM variable and soil 
+!    I_f Compute tendencies & Save initial situation
+!    I_g Save initial PCM situation
+!    I_h Read the PEMstart
+!    I_i Compute orbit criterion
 
 ! II  Run
 !    II_a update pressure, ice and tracers 
-!    II_b CO2 glaciers flows 
-!    II_c Update surface and soil temperatures
-!    II_d Update the tendencies and stopping criterion
+!    II_b Evolution of the ice
+!    II_c CO2 glaciers flows 
+!    II_d Update surface and soil temperatures
+!    II_e Update the tendencies 
+!    II_f Checking the stopping criterion
 
 ! III Output
-!    III_a Recomp tendencies for the start and startfi
+!    III_a Update surface value for the PCM start files
 !    III_b Write start and starfi.nc
 !    III_c Write start_pem
 
 !------------------------
-
 
 PROGRAM pem
@@ -32,15 +38,12 @@
                            hmons, summit, base,albedo_h2o_frost, &
                           frost_albedo_threshold,emissiv
-      use dimradmars_mod, only: totcloudfrac, albedo, & 
-                                ini_dimradmars_mod
-      use turb_mod, only: q2, wstar, ini_turb_mod
-      use dust_param_mod, only: tauscaling, ini_dust_param_mod
-!      use co2cloud_mod, only: mem_Mccn_co2, mem_Mh2o_co2,&
-!      &                        mem_Nccn_co2,ini_co2cloud
+      use dimradmars_mod, only: totcloudfrac, albedo
+      use turb_mod, only: q2, wstar
+      use dust_param_mod, only: tauscaling
       use netcdf, only: nf90_open,NF90_NOWRITE,nf90_noerr,nf90_strerror, &
                         nf90_get_var, nf90_inq_varid, nf90_inq_dimid, &
                         nf90_inquire_dimension,nf90_close
       use phyredem, only: physdem0, physdem1
-      use tracer_mod, only: noms,nqmx,igcm_h2o_ice ! tracer names
+      use tracer_mod, only: noms,igcm_h2o_ice ! tracer names
 
 ! For phyredem :
@@ -56,6 +59,4 @@
       USE iniphysiq_mod, ONLY: iniphysiq
       USE infotrac
-      USE temps_mod_evol, ONLY: nyear, dt_pem
-!     USE vertical_layers_mod, ONLY: ap,bp
       USE comcstfi_h, only: pi 
 
@@ -68,17 +69,24 @@
                            iflat
 
-      USE geometry_mod, only: longitude_deg,latitude_deg 
+      USE geometry_mod, only: latitude_deg 
 
       use pemredem, only:  pemdem1
-      USE soil_evolution_mod, ONLY: soil_pem_CN
+
 !!!!!!!!!!!!!!!!!!!!!!!!!!!!!! SOIL
-
+      USE soil_evolution_mod, ONLY: soil_pem, soil_pem_CN
       use comsoil_h_PEM, only: ini_comsoil_h_PEM,end_comsoil_h_PEM,nsoilmx_PEM, &
-                              TI_PEM,inertiedat_PEM,alph_PEM, beta_PEM, &        ! soil thermal inertia          
-                              tsoil_PEM ,       &        !number of subsurface layers
-                              mlayer_PEM,layer_PEM, &       ! soil mid layer depths
-                              fluxgeo, &  ! geothermal flux
-                              co2_adsorbded_phys ! mass of co2 in the regolith
+                              TI_PEM,inertiedat_PEM,alph_PEM, beta_PEM,         & ! soil thermal inertia          
+                              tsoil_PEM, mlayer_PEM,layer_PEM,                  & !number of subsurface layers, soil mid layer depths
+                              fluxgeo, co2_adsorbded_phys                         ! geothermal flux, mass of co2 in the regolith
       use adsorption_mod, only : regolith_co2adsorption
+
+!!! For orbit parameters
+      USE temps_mod_evol, ONLY: dt_pem, evol_orbit_pem, Max_iter_pem
+      use planete_h, only: aphelie, periheli, year_day, peri_day, &
+                          obliquit
+      use orbit_param_criterion_mod, only : orbit_param_criterion
+      use recomp_orb_param_mod, only: recomp_orb_param
+
+
   IMPLICIT NONE
 
@@ -104,5 +112,5 @@
 
 ! Variable for reading start.nc
-      character (len = *), parameter :: FILE_NAME_start = "start_0.nc" !Name of the file used for initialsing the PEM
+      character (len = *), parameter :: FILE_NAME_start = "start_evol.nc" !Name of the file used for initialsing the PEM
   !   variables dynamiques
   REAL vcov(ip1jm,llm),ucov(ip1jmp1,llm) ! vents covariants
@@ -120,5 +128,5 @@
 ! Variable for reading starfi.nc
 
-      character (len = *), parameter :: FILE_NAME = "startfi_0.nc" !Name of the file used for initialsing the PEM
+      character (len = *), parameter :: FILE_NAME = "startfi_evol.nc" !Name of the file used for initialsing the PEM
       integer :: ncid, varid,status                                !Variable for handling opening of files
       integer :: phydimid, subdimid, nlayerdimid, nqdimid          !Variable ID for Netcdf files
@@ -152,12 +160,7 @@
       REAL , dimension(:,:), allocatable :: min_h2o_ice_s_1        ! LON x LAT field : minimum of water ice at each point for the first year
       REAL , dimension(:,:), allocatable :: min_h2o_ice_s_2        ! LON x LAT field : minimum of water ice at each point for the second year
-      REAL , dimension(:,:,:), allocatable :: h2o_ice_first_last_day     ! LON x LAT x 2 field : First and Last value of a GCM year simulation of water ice
 
       REAL , dimension(:,:), allocatable :: min_co2_ice_s_1        ! LON x LAT field : minimum of water ice at each point for the first year
       REAL , dimension(:,:), allocatable :: min_co2_ice_s_2        ! LON x LAT field : minimum of water ice at each point for the second year
-      REAL , dimension(:,:,:), allocatable :: co2_ice_first_last_day     ! LON x LAT x 2 field : First and Last value of a GCM year simulation of water ice
-
-      REAL, dimension(:),allocatable  :: local_old_press           ! physical point field : Local pressure of initial/previous time step
-      REAL, dimension(:),allocatable  :: local_new_press           ! physical point field : Local pressure of current time step
 
       REAL :: global_ave_press_GCM
@@ -166,19 +169,12 @@
 
       REAL , dimension(:,:), allocatable ::  zplev_new
-      REAL , dimension(:,:), allocatable :: zplev_old
+      REAL , dimension(:,:), allocatable ::  zplev_gcm
       REAL , dimension(:,:,:), allocatable ::  zplev_new_timeseries  ! same but with the time series
-      REAL , dimension(:,:,:), allocatable :: zplev_old_timeseries! same but with the time series
-
-
-
-
-      REAL :: tot_co2_atm,tot_var_co2_atm
-
-
-      INTEGER :: year_iter  !Counter for the number of PEM iteration
+      REAL , dimension(:,:,:), allocatable :: zplev_old_timeseries   ! same but with the time series
+
       LOGICAL :: STOPPING_water   ! Logical : is the criterion (% of change in the surface of sublimating water ice) reached?
       LOGICAL :: STOPPING_1_water ! Logical : is there still water ice to sublimate?
-      LOGICAL :: STOPPING_co2   ! Logical : is the criterion (% of change in the surface of sublimating water ice) reached?
-      LOGICAL :: STOPPING_1_co2 ! Logical : is there still water ice to sublimate?
+      LOGICAL :: STOPPING_co2     ! Logical : is the criterion (% of change in the surface of sublimating water ice) reached?
+      LOGICAL :: STOPPING_1_co2   ! Logical : is there still water ice to sublimate?
 
       REAL, dimension(:,:,:),allocatable  :: q_co2_GCM ! Initial amount of co2 in the first layer
@@ -195,19 +191,13 @@
       REAL, ALLOCATABLE ::  q_h2o_GCM(:,:,:)
       REAL ,allocatable ::  q_h2o_PEM_phys(:,:)
-      real ,allocatable :: q_phys(:,:,:) 
       integer :: timelen
       REAL :: ave
 
       REAL, ALLOCATABLE :: p(:,:)  !(ngrid,llmp1)
-      REAL :: extra_mass ! Extra mass of a tracer if it is greater than 1
-
-      REAL :: deficit_mass ! Extra mass of a tracer if it is lower than 0
-
-
-
+      REAL :: extra_mass           ! Extra mass of a tracer if it is greater than 1
 
 !!!!!!!!!!!!!!!!!!!!!!!! SLOPE
       character*2 :: str2
-      REAL ,allocatable :: watercap_slope(:,:)    !(ngrid,nslope)
+      REAL ,allocatable :: watercap_slope(:,:)                           !(ngrid,nslope)
       REAL , dimension(:,:,:), allocatable :: min_co2_ice_slope_1        ! LON x LAT field : minimum of water ice at each point for the first year
       REAL , dimension(:,:,:), allocatable :: min_co2_ice_slope_2        ! LON x LAT field : minimum of water ice at each point for the second year
@@ -217,8 +207,8 @@
 
       REAL , dimension(:,:,:,:), allocatable :: co2_ice_GCM_slope        ! LON x LATX NSLOPE x Times field : co2 ice given by the GCM
-      REAL , dimension(:,:,:), allocatable :: co2_ice_GCM_phys_slope        ! LON x LATX NSLOPE x Times field : co2 ice given by the GCM
-
-
-      REAL, dimension(:,:),allocatable  :: initial_co2_ice_sublim_slope           ! physical point field : Logical array indicating sublimating point of co2 ice
+      REAL , dimension(:,:,:), allocatable :: co2_ice_GCM_phys_slope     ! LON x LATX NSLOPE x Times field : co2 ice given by the GCM
+
+
+      REAL, dimension(:,:),allocatable  :: initial_co2_ice_sublim_slope    ! physical point field : Logical array indicating sublimating point of co2 ice
       REAL, dimension(:,:),allocatable  :: initial_h2o_ice_slope           ! physical point field : Logical array indicating sublimating point of h2o ice
       REAL, dimension(:,:),allocatable  :: initial_co2_ice_slope           ! physical point field : Logical array indicating sublimating point of co2 ice
@@ -230,5 +220,5 @@
       REAL, dimension(:,:),allocatable  :: tendencies_h2o_ice_phys_slope   ! physical point field : Tendency of evolution of perenial co2 ice over a year
 
-      REAL,SAVE,ALLOCATABLE,DIMENSION(:) ::  co2_hmax                          ! Maximum height  for CO2 deposit on slopes (m)
+      REAL,SAVE,ALLOCATABLE,DIMENSION(:) ::  co2_hmax                      ! Maximum height  for CO2 deposit on slopes (m)
 
       REAL, PARAMETER :: rho_co2 = 1600           ! CO2 ice density (kg/m^3)
@@ -237,59 +227,43 @@
       REAL , dimension(:), allocatable :: flag_co2flow_mesh(:)  !(ngrid)          ! To flag where there is a glacier flow
 
-
 !!!!!!!!!!!!!!!!!!!!!!!!!!!!!! SURFACE/SOIL 
 
-
-     REAL, ALLOCATABLE :: tsurf_ave(:,:,:) ! LON x LAT x SLOPE field : Averaged Surface Temperature [K]
-     REAL, ALLOCATABLE  :: tsurf_ave_phys(:,:) ! IG x LAT x SLOPE field : Averaged Surface Temperature [K]
-     REAL, ALLOCATABLE :: tsoil_ave(:,:,:,:) ! LON x LAT x SLOPE field : Averaged Soil Temperature [K]
-     REAL, ALLOCATABLE :: tsoil_ave_yr1(:,:,:,:) ! LON x LAT x SLOPE field : Averaged Soil Temperature [K]
+     REAL, ALLOCATABLE :: tsurf_ave(:,:,:)          ! LON x LAT x SLOPE field : Averaged Surface Temperature [K]
+     REAL, ALLOCATABLE  :: tsurf_ave_phys(:,:)      ! IG x LAT x SLOPE field : Averaged Surface Temperature [K]
+     REAL, ALLOCATABLE :: tsoil_ave(:,:,:,:)        ! LON x LAT x SLOPE field : Averaged Soil Temperature [K]
+     REAL, ALLOCATABLE :: tsoil_ave_yr1(:,:,:,:)    ! LON x LAT x SLOPE field : Averaged Soil Temperature [K]
      REAL, ALLOCATABLE :: tsoil_ave_phys_yr1(:,:,:) !IG x SLOPE field : Averaged Soil Temperature [K]
 
-     REAL, ALLOCATABLE :: TI_GCM(:,:,:,:) ! LON x LAT x SLOPE field : Averaged Thermal Inertia  [SI]
-     REAL, ALLOCATABLE :: tsurf_GCM_timeseries(:,:,:,:) !LONX LAT x SLOPE XTULES field : NOn averaged Surf Temperature [K]
+     REAL, ALLOCATABLE :: TI_GCM(:,:,:,:)                  ! LON x LAT x SLOPE field : Averaged Thermal Inertia  [SI]
+     REAL, ALLOCATABLE :: tsurf_GCM_timeseries(:,:,:,:)    !LONX LAT x SLOPE XTULES field : NOn averaged Surf Temperature [K]
      REAL, ALLOCATABLE :: tsurf_phys_GCM_timeseries(:,:,:) !IG x SLOPE XTULES field : NOn averaged Surf Temperature [K]
 
      REAL, ALLOCATABLE :: tsoil_phys_PEM_timeseries(:,:,:,:) !IG x SLOPE XTULES field : NOn averaged Soil Temperature [K]
-     REAL, ALLOCATABLE :: tsoil_GCM_timeseries(:,:,:,:,:) !IG x SLOPE XTULES field : NOn averaged Soil Temperature [K]
-
-     REAL, ALLOCATABLE :: tsurf_ave_yr1(:,:,:) ! LON x LAT x SLOPE field : Averaged Surface Temperature of the first year of the gcm [K]
+     REAL, ALLOCATABLE :: tsoil_GCM_timeseries(:,:,:,:,:)    !IG x SLOPE XTULES field : NOn averaged Soil Temperature [K]
+
+     REAL, ALLOCATABLE :: tsurf_ave_yr1(:,:,:)     ! LON x LAT x SLOPE field : Averaged Surface Temperature of the first year of the gcm [K]
      REAL, ALLOCATABLE  :: tsurf_ave_phys_yr1(:,:) ! IG x LAT x SLOPE field : Averaged Surface Temperature of first call of the gcm [K]
 
-
-
-     REAL :: tol_soil = 1.e-6
-     INTEGER :: countmax = 15
-     INTEGER :: countloop
-     REAL, ALLOCATABLE :: tsoil_phys_PEM_saved(:,:,:)
-     REAL :: error_tsoil
-
-
-     LOGICAL :: firstcall
-!    REAL, PARAMETER :: daysec=88775.              ! duree du sol (s)  ~88775 s
-     REAL, PARAMETER :: year_day = 669
      REAL, PARAMETER :: year_step = 1
+     INTEGER :: year_iter        !Counter for the number of PEM iteration
+     INTEGER :: year_iter_max
      REAL :: timestep
 
-     REAL, ALLOCATABLE :: inertiesoil(:,:) ! Thermal inertia of the mesh for restart
-
-     REAL, ALLOCATABLE :: TI_GCM_phys(:,:,:) ! Averaged GCM Thermal Inertia  [SI]
+     REAL, ALLOCATABLE :: inertiesoil(:,:)    ! Thermal inertia of the mesh for restart
+
+     REAL, ALLOCATABLE :: TI_GCM_phys(:,:,:)  ! Averaged GCM Thermal Inertia  [SI]
      REAL, ALLOCATABLE :: TI_GCM_start(:,:,:) ! Averaged GCM Thermal Inertia  [SI]
-
-     REAL,ALLOCATABLE  :: q_h2o_PEM_phys_ave(:) ! averaged water vapor content
-     REAL,ALLOCATABLE  :: interp_coef(:)
 
      REAL,ALLOCATABLE  :: ice_depth(:,:)
      REAL,ALLOCATABLE  :: TI_locslope(:,:)
      REAL,ALLOCATABLE  :: Tsoil_locslope(:,:)
-     REAL,ALLOCATABLE  :: Tsoil_locslope_CN(:,:)
      REAL,ALLOCATABLE  :: Tsurf_locslope(:)
-     REAL,ALLOCATABLE  :: Tsurf_locslope_prev(:)
      REAL,ALLOCATABLE  :: alph_locslope(:,:)
      REAL,ALLOCATABLE  :: beta_locslope(:,:)   
-     REAL :: kcond
+
      REAL,ALLOCATABLE  :: Tsurfave_before_saved(:,:)
      REAL, ALLOCATABLE :: delta_co2_adsorbded(:)
      REAL :: totmass_adsorbded
+
 !!!!!!!!!!!!!!!!!!!!!!!!!!!!
 
@@ -310,5 +284,8 @@
       time_phys=0. !test
 
-!      n_band_lat=18
+! Some constants
+
+      ngrid=ngridmx
+      nlayer=llm
 
       m_co2 = 44.01E-3  ! CO2 molecular mass (kg/mol)   
@@ -317,5 +294,8 @@
       B=1/m_noco2
 
-
+      year_day=669
+      daysec=88775.
+      dtphys=0
+      timestep=year_day*daysec/year_step
 
 !------------------------
@@ -324,11 +304,11 @@
 !    I_a READ run.def 
 
-
 !------------------------
 
 !----------------------------READ run.def ---------------------
       CALL conf_gcm( 99, .TRUE. )
-      CALL conf_evol( 99, .TRUE. )
-
+
+      call infotrac_init
+      nq=nqtot
 
 !------------------------
@@ -336,19 +316,13 @@
 ! I   Initialisation
 !    I_a READ run.def 
-!    I_b READ starfi_0.nc
-
-!----------------------------READ startfi.nc --------------------- 
-
-!----------------------------initialisation --------------------- 
-
+!    I_b READ of start_evol.nc and starfi_evol.nc
+
+!------------------------
+
+!----------------------------Initialisation : READ some constant of startfi_evol.nc --------------------- 
+
+! In the gcm, these values are given to the physic by the dynamic.
+! Here we simply read them in the startfi_evol.nc file
       status =nf90_open(FILE_NAME, NF90_NOWRITE, ncid)
-      status =nf90_inq_dimid(ncid, "physical_points", phydimid)
-      status =nf90_inquire_dimension(ncid, phydimid, len = ngrid)
-
-      status =nf90_inq_dimid(ncid, "nlayer", nlayerdimid)
-      status =nf90_inquire_dimension(ncid, nlayerdimid, len = nlayer)
-
-      status =nf90_inq_dimid(ncid,"number_of_advected_fields",nqdimid)
-      status =nf90_inquire_dimension(ncid, nqdimid, len = nq)
 
       allocate(longitude(ngrid))
@@ -372,9 +346,5 @@
       status =nf90_close(ncid)
 
-
-
 !----------------------------READ start.nc --------------------- 
-    
-     call infotrac_init
 
      allocate(q(ip1jmp1,llm,nqtot))
@@ -392,35 +362,24 @@
      status = nf90_get_var(ncid, bpvarid, bp)
      status =nf90_close(ncid)
-     
-        
-   
-    daysec=88775.
-    dtphys=0
-
- 
-
-    CALL iniphysiq(iim,jjm,llm, &
+
+     CALL iniphysiq(iim,jjm,llm, &
           (jjm-1)*iim+2,comm_lmdz, &
           daysec,day_ini,dtphys/nsplit_phys, &
           rlatu,rlatv,rlonu,rlonv,aire,cu,cv,rad,g,r,cpp, &
           iflag_phys)
-   DO nnq=1,nqtot
-    if(noms(nnq).eq."h2o_ice") igcm_h2o_ice = nnq
-   ENDDO 
-
- 
-!----------------------------reading ---------------------
-
+
+     DO nnq=1,nqtot
+       if(noms(nnq).eq."h2o_ice") igcm_h2o_ice = nnq
+     ENDDO 
+
+!----------------------------READ startfi.nc --------------------- 
 
 ! First we read the initial state (starfi.nc)
 
-
-       allocate(watercap_slope(ngrid,nslope))
-       allocate(TI_GCM_start(ngrid,nsoilmx,nslope))
-       allocate(q_h2o_PEM_phys_ave(ngrid))
+      allocate(watercap_slope(ngrid,nslope))
+      allocate(TI_GCM_start(ngrid,nsoilmx,nslope))
       allocate(inertiesoil(ngrid,nsoilmx))
 
-
-         CALL phyetat0 (FILE_NAME,0,0, &
+      CALL phyetat0 (FILE_NAME,0,0, &
               nsoilmx,ngrid,nlayer,nq,   &
               day_ini,time_phys,         &
@@ -432,40 +391,48 @@
               qsurf_slope,watercap_slope)
 
-
-
-     deallocate(TI_GCM_start) !not used then
-
+     if(soil_pem) then
+       deallocate(TI_GCM_start) !not used then
+     endif
+
+! Remove unphysical values of surface tracer
      DO i=1,ngrid
-         DO nnq=1,nqtot
-           DO islope=1,nslope
-             if(qsurf_slope(i,nnq,islope).LT.0) then
-                qsurf_slope(i,nnq,islope)=0.
-             endif
-           enddo
+       DO nnq=1,nqtot
+         DO islope=1,nslope
+           if(qsurf_slope(i,nnq,islope).LT.0) then
+             qsurf_slope(i,nnq,islope)=0.
+           endif
          enddo
        enddo
+     enddo
+
+!------------------------
+
+! I   Initialisation
+!    I_a READ run.def 
+!    I_b READ of start_evol.nc and starfi_evol.nc
+!    I_c Subslope parametrisation
+
+!------------------------
+
+!----------------------------Subslope parametrisation definition --------------------- 
 
 !     Define some slope statistics
-
-
-      
-
-       iflat=1
-       DO islope=2,nslope
-         IF(abs(def_slope_mean(islope)).lt. &
-           abs(def_slope_mean(iflat)))THEN
-           iflat = islope
-         ENDIF     
-
-       ENDDO
-       PRINT*,'Flat slope for islope = ',iflat
-       PRINT*,'corresponding criterium = ',def_slope_mean(iflat)
+     iflat=1
+     DO islope=2,nslope
+       IF(abs(def_slope_mean(islope)).lt. &
+         abs(def_slope_mean(iflat))) THEN
+         iflat = islope
+       ENDIF     
+     ENDDO
+
+     PRINT*,'Flat slope for islope = ',iflat
+     PRINT*,'corresponding criterium = ',def_slope_mean(iflat)
+
 ! CO2 max thickness (for glaciers flows)
-
-       allocate(co2_hmax(nslope)
-       if(nslope.eq.7) ! ugly way to implement that ...
+       allocate(co2_hmax(nslope))
+       if(nslope.eq.7) then ! ugly way to implement that ...
 !        CF documentation that explain how the values are computed
          co2_hmax(1) = 1.5
-         co2_hmax(7) = co2_max(1)
+         co2_hmax(7) = co2_hmax(1)
          co2_hmax(2) = 2.4
          co2_hmax(6) = co2_hmax(2)
@@ -475,17 +442,17 @@
        endif
 
-
-
-
+     allocate(flag_co2flow(ngrid,nslope))
+     allocate(flag_co2flow_mesh(ngrid))
 
        flag_co2flow(:,:) = 0.     
        flag_co2flow_mesh(:) = 0.
 
-!------------------------
+!---------------------------- READ GCM data --------------------- 
 
 ! I   Initialisation
-!    I_a READ run.def , run_pem.def
-!    I_b READ starfi_0.nc
-!    I_c READ GCM data and convert to the physical grid 
+!    I_a READ run.def 
+!    I_b READ of start_evol.nc and starfi_evol.nc
+!    I_c Subslope parametrisation
+!    I_d READ GCM data and convert to the physical grid 
 
 !------------------------
@@ -493,6 +460,6 @@
 ! First we read the evolution of water and co2 ice (and the mass mixing ratio) over the first year of the GCM run, saving only the minimum value
 
-
-     call nb_time_step_GCM("concat_year_one.nc",timelen)
+     call nb_time_step_GCM("data_GCM_Y1.nc",timelen)
+
      allocate(min_h2o_ice_s_1(iim+1,jjm+1))
      allocate(min_co2_ice_s_1(iim+1,jjm+1))
@@ -506,13 +473,6 @@
      allocate(tsurf_ave(iim+1,jjm+1,nslope))
      allocate(tsurf_ave_yr1(iim+1,jjm+1,nslope))
-     allocate(tsoil_ave(iim+1,jjm+1,nsoilmx,nslope))
-     allocate(tsoil_ave_yr1(iim+1,jjm+1,nsoilmx,nslope))
-     allocate(tsoil_ave_phys_yr1(ngrid,nsoilmx_PEM,nslope))
      allocate(tsurf_ave_phys(ngrid,nslope))
      allocate(tsurf_ave_phys_yr1(ngrid,nslope))
-     allocate(TI_GCM(iim+1,jjm+1,nsoilmx,nslope))
-     allocate(tsoil_GCM_timeseries(iim+1,jjm+1,nsoilmx,nslope,timelen))
-     allocate(tsoil_phys_PEM_timeseries(ngrid,nsoilmx_PEM,nslope,timelen))
-
      allocate(tsurf_GCM_timeseries(iim+1,jjm+1,nslope,timelen))
      allocate(tsurf_phys_GCM_timeseries(ngrid,nslope,timelen))
@@ -520,15 +480,20 @@
      allocate(co2_ice_GCM_slope(iim+1,jjm+1,nslope,timelen))
      allocate(Tsurfave_before_saved(ngrid,nslope))
-     allocate(tsoil_phys_PEM_saved(ngrid,nsoilmx_PEM,nslope))
+     allocate(tsoil_ave(iim+1,jjm+1,nsoilmx,nslope))
+     allocate(tsoil_ave_yr1(iim+1,jjm+1,nsoilmx,nslope))
+     allocate(tsoil_ave_phys_yr1(ngrid,nsoilmx_PEM,nslope))
+     allocate(TI_GCM(iim+1,jjm+1,nsoilmx,nslope))
+     allocate(tsoil_GCM_timeseries(iim+1,jjm+1,nsoilmx,nslope,timelen))
+     allocate(tsoil_phys_PEM_timeseries(ngrid,nsoilmx_PEM,nslope,timelen))
      allocate(delta_co2_adsorbded(ngrid))
-     allocate(q_phys(ngrid,llm,nqtot))
-
-
-
-     call read_data_GCM("concat_year_one.nc", min_h2o_ice_s_1,min_co2_ice_s_1,iim,jjm,nlayer,vmr_co2_gcm,ps_GCM_yr1,timelen,min_co2_ice_slope_1,min_h2o_ice_slope_1,&   
+
+     print *, "Downloading data Y1..."
+
+     call read_data_GCM("data_GCM_Y1.nc", min_h2o_ice_s_1,min_co2_ice_s_1,iim,jjm,nlayer,vmr_co2_gcm,ps_GCM_yr1,timelen,min_co2_ice_slope_1,min_h2o_ice_slope_1,&   
                        nslope,tsurf_ave_yr1,tsoil_ave_yr1, tsurf_GCM_timeseries,tsoil_GCM_timeseries,TI_GCM,q_co2_GCM,q_h2o_GCM,co2_ice_GCM_slope)
 
-
 ! Then we read the evolution of water and co2 ice (and the mass mixing ratio) over the second year of the GCM run, saving only the minimum value
+
+     print *, "Downloading data Y1 done"
 
      allocate(min_h2o_ice_s_2(iim+1,jjm+1))
@@ -537,12 +502,12 @@
      allocate(min_h2o_ice_slope_2(iim+1,jjm+1,nslope))
 
-     call read_data_GCM("concat_year_two.nc", min_h2o_ice_s_2,min_co2_ice_s_2,iim,jjm,nlayer,vmr_co2_gcm,ps_GCM,timelen,min_co2_ice_slope_2,min_h2o_ice_slope_2, &
+     print *, "Downloading data Y2"
+
+     call read_data_GCM("data_GCM_Y2.nc", min_h2o_ice_s_2,min_co2_ice_s_2,iim,jjm,nlayer,vmr_co2_gcm,ps_GCM,timelen,min_co2_ice_slope_2,min_h2o_ice_slope_2, &
                   nslope,tsurf_ave,tsoil_ave, tsurf_GCM_timeseries,tsoil_GCM_timeseries,TI_GCM,q_co2_GCM,q_h2o_GCM,co2_ice_GCM_slope)
 
-
-
+     print *, "Downloading data Y2 done"
 
 ! The variables in the dynamic grid are transfered to the physical grid
-
 
      allocate(vmr_co2_gcm_phys(ngrid,timelen))
@@ -552,52 +517,43 @@
      allocate(q_co2_GCM_phys(ngrid,timelen))
      allocate(q_co2_PEM_phys(ngrid,timelen))
-
+     allocate(ps_phys(ngrid))
+     allocate(ps_phys_timeseries(ngrid,timelen))
+     allocate(ps_phys_timeseries_yr1(ngrid,timelen))
 
      CALL gr_dyn_fi(timelen,iip1,jjp1,ngridmx,vmr_co2_gcm,vmr_co2_gcm_phys)
      CALL gr_dyn_fi(timelen,iip1,jjp1,ngridmx,q_h2o_GCM,q_h2o_GCM_phys)
      CALL gr_dyn_fi(timelen,iip1,jjp1,ngridmx,q_co2_GCM,q_co2_GCM_phys)
-
-     do nnq=1,nqtot
-
-        call gr_dyn_fi(llm,iip1,jjp1,ngridmx,q(:,:,nnq),q_phys(:,:,nnq))
-     enddo
-
+     call gr_dyn_fi(1,iip1,jjp1,ngridmx,ps,ps_phys)
+     call gr_dyn_fi(timelen,iip1,jjp1,ngridmx,ps_GCM,ps_phys_timeseries)
+     call gr_dyn_fi(timelen,iip1,jjp1,ngridmx,ps_GCM_yr1,ps_phys_timeseries_yr1)
+     CALL gr_dyn_fi(nslope,iip1,jjp1,ngridmx,tsurf_ave,tsurf_ave_phys)
+     CALL gr_dyn_fi(nslope,iip1,jjp1,ngridmx,tsurf_ave_yr1,tsurf_ave_phys_yr1)
 
      deallocate(vmr_co2_gcm)
      deallocate(q_h2o_GCM)
      deallocate(q_co2_GCM)
-
-
-    q_co2_PEM_phys(:,:)=  q_co2_GCM_phys(:,:)
-    q_h2o_PEM_phys(:,:)=  q_h2o_GCM_phys(:,:)
-
-
-     allocate(ps_phys(ngrid))
-     allocate(ps_phys_timeseries(ngrid,timelen))
-     allocate(ps_phys_timeseries_yr1(ngrid,timelen))
-
-
-
-
-
-     call gr_dyn_fi(1,iip1,jjp1,ngridmx,ps,ps_phys)
-
-
-! for the time series:
-
-
-
-    call gr_dyn_fi(timelen,iip1,jjp1,ngridmx,ps_GCM,ps_phys_timeseries)
-    call gr_dyn_fi(timelen,iip1,jjp1,ngridmx,ps_GCM_yr1,ps_phys_timeseries_yr1)
-    deallocate(ps_GCM)
-    deallocate(ps_GCM_yr1)
-
-
-!!!!!!!!!!!!!!!!!!!!! Initialisation for soil_PEM
+     deallocate(ps_GCM)
+     deallocate(ps_GCM_yr1)
+     deallocate(tsurf_ave)
+     deallocate(tsurf_ave_yr1)
+
+     q_co2_PEM_phys(:,:)=  q_co2_GCM_phys(:,:)
+     q_h2o_PEM_phys(:,:)=  q_h2o_GCM_phys(:,:)
+
+!------------------------
+
+! I   Initialisation
+!    I_a READ run.def 
+!    I_b READ of start_evol.nc and starfi_evol.nc
+!    I_c Subslope parametrisation
+!    I_d READ GCM data and convert to the physical grid 
+!    I_e Initialisation of the PEM variable and soil 
+
+!------------------------
+
+!---------------------------- Initialisation of the PEM soil and values --------------------- 
 
       call end_comsoil_h_PEM
       call ini_comsoil_h_PEM(ngrid,nslope)
-      timestep=year_day*daysec/year_step
-
 
       allocate(ice_depth(ngrid,nslope))
@@ -605,129 +561,63 @@
 
       DO islope = 1,nslope
+        if(soil_pem) then
           CALL gr_dyn_fi(nsoilmx,iip1,jjp1,ngridmx,TI_GCM(:,:,:,islope),TI_GCM_phys(:,:,islope))
+        endif !soil_pem
+        DO t=1,timelen
+          CALL gr_dyn_fi(1,iip1,jjp1,ngridmx,tsurf_GCM_timeseries(:,:,islope,t),tsurf_phys_GCM_timeseries(:,islope,t))
+          CALL gr_dyn_fi(1,iip1,jjp1,ngridmx,co2_ice_GCM_slope(:,:,islope,t),co2_ice_GCM_phys_slope(:,islope,t))
+        enddo
       ENDDO
 
-
+      deallocate(co2_ice_GCM_slope)
+      deallocate(TI_GCM)
+
+  if(soil_pem) then
+
+      deallocate(tsurf_GCM_timeseries)
       call soil_settings_PEM(ngrid,nslope,nsoilmx_PEM,nsoilmx,TI_GCM_phys,TI_PEM)
 
-      deallocate(TI_GCM)
-
-
       DO islope = 1,nslope
-
         DO l=1,nsoilmx
            CALL gr_dyn_fi(1,iip1,jjp1,ngridmx,tsoil_ave_yr1(:,:,l,islope),tsoil_ave_phys_yr1(:,l,islope))
+           CALL gr_dyn_fi(1,iip1,jjp1,ngridmx,tsoil_ave(:,:,l,islope),tsoil_PEM(:,l,islope))
+           DO t=1,timelen
+             CALL gr_dyn_fi(1,iip1,jjp1,ngridmx,tsoil_GCM_timeseries(:,:,l,islope,t),tsoil_phys_PEM_timeseries(:,l,islope,t))
+           ENDDO
         ENDDO
         DO l=nsoilmx+1,nsoilmx_PEM
            CALL gr_dyn_fi(1,iip1,jjp1,ngridmx,tsoil_ave_yr1(:,:,nsoilmx,islope),tsoil_ave_phys_yr1(:,l,islope))
-        ENDDO
-      ENDDO
-
-
-
-       deallocate(tsoil_ave_yr1)
-
-
-
-
-
-
-
-
-
-
-      DO islope = 1,nslope
-
-        DO l=1,nsoilmx
-           CALL gr_dyn_fi(1,iip1,jjp1,ngridmx,tsoil_ave(:,:,l,islope),tsoil_PEM(:,l,islope))
-        ENDDO
-        DO l=nsoilmx+1,nsoilmx_PEM
            CALL gr_dyn_fi(1,iip1,jjp1,ngridmx,tsoil_ave(:,:,nsoilmx,islope),tsoil_PEM(:,l,islope))
         ENDDO
       ENDDO
-     
-
-
-       deallocate(tsoil_ave)
-
-
-      DO islope = 1,nslope
-       
-        DO l=1,nsoilmx
-          DO t=1,timelen
-           CALL gr_dyn_fi(1,iip1,jjp1,ngridmx,tsoil_GCM_timeseries(:,:,l,islope,t),tsoil_phys_PEM_timeseries(:,l,islope,t))
-          ENDDO
-        ENDDO
-      ENDDO
-
+
+      deallocate(tsoil_ave_yr1)
+      deallocate(tsoil_ave)
       deallocate(tsoil_GCM_timeseries)
-     
- 
-
-
-       CALL gr_dyn_fi(nslope,iip1,jjp1,ngridmx,tsurf_ave,tsurf_ave_phys)
-       
-       CALL gr_dyn_fi(nslope,iip1,jjp1,ngridmx,tsurf_ave_yr1,tsurf_ave_phys_yr1)
-
-       deallocate(tsurf_ave)
-       deallocate(tsurf_ave_yr1)
-
-   
-
-
-      DO islope = 1,nslope
-
-        DO t=1,timelen
-          CALL gr_dyn_fi(1,iip1,jjp1,ngridmx,tsurf_GCM_timeseries(:,:,islope,t),tsurf_phys_GCM_timeseries(:,islope,t))
-        enddo
-      enddo
-      deallocate(tsurf_GCM_timeseries)
-
-
-  DO islope = 1,nslope
-
-        DO t=1,timelen
-          CALL gr_dyn_fi(1,iip1,jjp1,ngridmx,co2_ice_GCM_slope(:,:,islope,t),co2_ice_GCM_phys_slope(:,islope,t))
-        enddo
-      enddo
-
-
-
-      deallocate(co2_ice_GCM_slope)
-
-
+  endif !soil_pem
 
 !------------------------
 
 ! I   Initialisation
-!    I_a READ run.def , run_pem.def
-!    I_b READ starfi_0.nc
-!    I_c READ GCM data and convert to the physical grid 
-!    I_d Compute tendencies & Save initial situation
-
-!------------------------
-
-
-
-
-
-!----- Compute tendencies
-
+!    I_a READ run.def 
+!    I_b READ of start_evol.nc and starfi_evol.nc
+!    I_c Subslope parametrisation
+!    I_d READ GCM data and convert to the physical grid 
+!    I_e Initialisation of the PEM variable and soil 
+!    I_f Compute tendencies & Save initial situation
+
+!----- Compute tendencies from the PCM run
 
      allocate(tendencies_h2o_ice(iim+1,jjm+1))
      allocate(tendencies_h2o_ice_phys(ngrid))
-
      allocate(tendencies_co2_ice(iim+1,jjm+1))
      allocate(tendencies_co2_ice_phys(ngrid))
-
      allocate(tendencies_co2_ice_slope(iim+1,jjm+1,nslope))
      allocate(tendencies_co2_ice_phys_slope(ngrid,nslope))
      allocate(tendencies_co2_ice_phys_slope_ini(ngrid,nslope))
-
-
      allocate(tendencies_h2o_ice_slope(iim+1,jjm+1,nslope))
      allocate(tendencies_h2o_ice_phys_slope(ngrid,nslope))
 
-!  Compute the tendencies of the evolution of water ice over the years
+!  Compute the tendencies of the evolution of ice over the years
 
       call compute_tendencies(tendencies_h2o_ice,min_h2o_ice_s_1,&
@@ -740,5 +630,4 @@
              min_co2_ice_slope_2,iim,jjm,ngrid,tendencies_co2_ice_phys_slope,nslope)
 
-
       tendencies_co2_ice_phys_slope_ini(:,:)=tendencies_co2_ice_phys_slope(:,:)
 
@@ -746,6 +635,16 @@
              min_h2o_ice_slope_2,iim,jjm,ngrid,tendencies_h2o_ice_phys_slope,nslope)
 
-     
-!----- Save initial situation
+!------------------------
+
+! I   Initialisation
+!    I_a READ run.def 
+!    I_b READ of start_evol.nc and starfi_evol.nc
+!    I_c Subslope parametrisation
+!    I_d READ GCM data and convert to the physical grid 
+!    I_e Initialisation of the PEM variable and soil 
+!    I_f Compute tendencies & Save initial situation
+!    I_g Save initial PCM situation
+
+!---------------------------- Save initial PCM situation --------------------- 
 
      allocate(initial_h2o_ice(ngrid))
